//#include <stream.h>
//#include <strings.h>
#include <iostream.h>
#include <string.h>
#include "polka.H"
#include "qsort.H"

extern MyAnimator qsortA;
int a[500];

void quicksort(int,int);
int partition(int,int,int);
int findpivot(int,int);
void squicksort(int,int);



main(int, char **)
{
   int n,i,count;

   qsortA.RegisterAlgoEvt("Init",NULL);
   qsortA.RegisterAlgoEvt("Input","dd");
   qsortA.RegisterAlgoEvt("Ready","d");
   qsortA.RegisterAlgoEvt("Exchange","dd");
   qsortA.RegisterAlgoEvt("Wait",NULL);

   qsortA.SendAlgoEvt("Init",NULL);

   printf("Enter number of elements in the array\n");
   scanf("%d", &n);
//   cout << "Enter number of elements in the array\n";
//   cin >> n;

   printf("Enter the elements\n");
//   cout << "Enter the elements\n";
   for (count=0; count<n; ++count)
      { 
	   
//	   cin >> a[count];
	int k;
    scanf("%d", &k);
	qsortA.SendAlgoEvt("Input",count,k);//a[count]);
      }

   qsortA.SendAlgoEvt("Ready",n);;

   quicksort(0,n-1);

   printf("The sorted values are\n   ");
   for (i=0; i<n; i++)
     printf("%d ",a[i]);
   printf("\n");

   while (1) 
     qsortA.SendAlgoEvt("Wait");
}



void
quicksort(int i, int j)
{
   int pivotindex, k;

   pivotindex = findpivot(i,j);
   if (pivotindex != -1) 
     {
       k = partition(i,j,pivotindex);
       /* thread; */
       
       if (k-1-i > 20)
          quicksort(i,k-1);
       else
          squicksort(i,k-1);

       if (j-k-1 > 20)
          quicksort(k+1,j);
       else
          squicksort(k+1,j);
     }
}



int
partition(int i, int j, int pivotindex)
{
   int l,r,temp,pivot;

   pivot = a[pivotindex];

   if (pivotindex != j) {
     temp = a[j];
     a[j] = a[pivotindex];
     a[pivotindex] = temp;
     qsortA.SendAlgoEvt("Exchange",pivotindex,j);
     }
      
   l = i-1;
   r = j;

   do
     {
       do 
         l++;
       while (a[l] < pivot);
       do
         r--;
       while ((r > l) && (a[r] > pivot));
       if (r <= l) break;
       qsortA.SendAlgoEvt("Exchange",l,r);
       temp = a[l];
       a[l] = a[r];
       a[r] = temp;
     }
   while (r > l);
   qsortA.SendAlgoEvt("Exchange",l,j);
   temp = a[l];
   a[l] = a[j];
   a[j] = temp;
   return(l);
}


int
findpivot(int i, int j)
{
   int k;

   k = (i+j)/2;
   if (a[i] < a[j]) 
     {
       if (a[k] < a[i])
          return(i);
       else
         {
           if (a[k] < a[j])
              return(k);
           else
              return(j);
         }
     }
   else
     {
       if (a[k] < a[j])
          return(j);
       else
         {
           if (a[k] < a[i])
              return(k);
           else
              return(i);
         }
     }
}



void
squicksort(int i, int j)
{
   int pivotindex, k, temp;

   if (i == j) return;
   if (i == j-1)
     {
       if (a[i] > a[j])
         {
           qsortA.SendAlgoEvt("Exchange",i,j);
           temp = a[i];
           a[i] = a[j];
           a[j] = temp;
         }
       return;
     }
   pivotindex = findpivot(i,j);
   if (pivotindex != -1) 
     {
       k = partition(i,j,pivotindex);

       squicksort(i,k-1);
       squicksort(k+1,j);
     }
}






