#include <iostream.h>
#include <string.h>
#include "polka.H"
#include "quicksort.H"


void qquicksort(int,int);


extern MyAnimator qs_anim;
int a[200],n;

main(int argc, char *argv[])
{
   int count;

   printf("Quicksort\n");

   qs_anim.RegisterAlgoEvt("Init",NULL);
   qs_anim.RegisterAlgoEvt("Input","dd");
   qs_anim.RegisterAlgoEvt("Display","d");
   qs_anim.RegisterAlgoEvt("Compare","dd");
   qs_anim.RegisterAlgoEvt("Exchange","dd");
   qs_anim.RegisterAlgoEvt("InPlace","d");
   qs_anim.RegisterAlgoEvt("Wait",NULL);

   qs_anim.SendAlgoEvt("Init");

   printf("Input number of elts in array\n");
   scanf("%d", &n);

   printf("Enter the elements (must be ints from 0 -> n-1)\n");
   for (count=0; count<n; ++count)
      { scanf("%d", &a[count]);
	qs_anim.SendAlgoEvt("Input",count,a[count]);
      }

   qs_anim.SendAlgoEvt("Display",n);
   qquicksort(0,n-1);

   for (count=0; count<n; ++count)
       printf("%d ", a[count]);
   printf("\n");

   while (1)
      qs_anim.SendAlgoEvt("Wait");
}


void
qquicksort(int lo, int hi)
{
   int i,j,part,temp;

   if (hi > lo)
      { if (lo == hi-1)
	   { if (a[lo] > a[hi])
		{ temp = a[lo];
		  a[lo] = a[hi];
		  a[hi] = temp;
                  qs_anim.SendAlgoEvt("Exchange",lo,hi);
		}
             return;
	   }

	part = a[hi];
	i = lo-1;
	j = hi;

	do
	   { do
		{ i++;
		}
	     while (a[i] < part);
	     do
		{ j--;
		}
	     while ((j>i) && (a[j] > part));
	     if (j <= i) break;
		 { qs_anim.SendAlgoEvt("Exchange",i,j);
                   temp = a[i];
                 }
	     a[i] = a[j];
	     a[j] = temp;
	   }
	while (j>i);

        qs_anim.SendAlgoEvt("Exchange",i,hi);
	temp = a[i];
	a[i] = a[hi];
	a[hi] = temp;

	qquicksort(lo, i-1);
	qquicksort(i+1, hi);
      }
}
