#include <iostream.h>
#include <string.h>
//#include <stream.h>
//#include <strings.h>
#include <stdlib.h>
#include <polka.H>
#include "tdq.H"

extern MyAnimator tdq;


main(int argc, char *argv[])
{
   int scache[CACHE_X][CACHE_Y], seed, queries[10];
   int row,col,time, q_num = 0, q_col;
   float rval;

   tdq.RegisterAlgoEvt("Init",NULL);
   tdq.RegisterAlgoEvt("Input","ddd");
   tdq.RegisterAlgoEvt("Ready","d");
   tdq.RegisterAlgoEvt("Clock","d");
   tdq.RegisterAlgoEvt("Colors","ddd");
   tdq.RegisterAlgoEvt("Query","ddd");
   tdq.RegisterAlgoEvt("WAIT",NULL);

/*
   cout << "Animation of queries on a cached time sensitive database\n";
   cout << "--------------------------------------------------------\n\n";
   cout << "by: Tom Gay\n\n\n";
   cout << "This simulation attempts to show the effect of passing time on a\n";
   cout << "database which has temporaly dependent information records.\n";
   cout << "(Such as flight departure times for an airline system.)  The \n";
   cout << "idea is that when a query is first made a 'super-cache' is \n";
   cout << "loaded not only with the records that are valid at the time\n";
   cout << "of that query, but all records that will eventually be valid\n";
   cout << "within a given time window.  The super-cache is in the center\n";
   cout << "section of the window represented by a two dimensional array\n";
   cout << "of rectangles.  Each rectangle represents a record and has a\n";
   cout << "'time number' associated with it.  (This might correspond in\n";
   cout << "reality to a departure time, for example.)  As time elapses\n";
   cout << "the number on the clock, shown in the upper right hand corner\n";
   cout << "of the window, grows and the color of the data records in the \n";
   cout << "supercache progresses from white, through shades of green from \n";
   cout << "lighter to darker, and then eventually to black. If a\n";
   cout << "record's time number falls within a given range from the current\n";
   cout << "time forward, in this case 12 units, it is filled with a shade \n";
   cout << "green corresponding to its time number.  If the time shown on \n";
   cout << "the clock has passed the time number of a given record, that\n";
   cout << "record becomes black, and if the time number of a record is\n";
   cout << "not yet valid, it is greater than the current time plus the \n";
   cout << "time window amount, it is shown white.\n\n";
   cout << "Queries are launched at random times by the simulation.  All\n";
   cout << "queries are made on a specific column of data in the super cache\n";
   cout << "chosen at the beginning of the simulation at random.  \n";
   cout << "10 queries are taken in all and lined\n";
   cout << "up at the bottom of the screen.  This allows the user to see how\n";
   cout << "the query results change over time.  Each query is labeled with\n";
   cout << "the time at which it was taken and each record labeled with its\n";
   cout << "time number.\n\n";
   cout << "Each time a query is made, the records in the data base that \n";
   cout << "correspond to the records in the super cache that are a part of\n";
   cout << "the query result must be poled to determine if an changes have \n";
   cout << "been made.  This is shown by a flashing red outline around a\n";
   cout << "rectangle in the data base.  Also, at a random time, a change \n";
   cout << "may be made on any given record in the database.\n";
   cout << "This is represented by a blue rectangle moving into the data \n";
   cout << "base and replacing an old record.  If this changed record is one\n";
   cout << "which is contained in the super cache,  and is in the set of \n";
   cout << "data records which the query produces, then the super cache will\n";
   cout << "be updated at the time of the next query.\n\n";
*/

   printf("Animation of queries on a cached time sensitive database\n");
   printf("--------------------------------------------------------\n\n");
   printf("by: Tom Gay\n\n\n");
   printf("This simulation attempts to show the effect of passing time on a\n");
   printf("database which has temporaly dependent information records.\n");
   printf("(Such as flight departure times for an airline system.)  The \n");
   printf("idea is that when a query is first made a 'super-cache' is \n");
   printf("loaded not only with the records that are valid at the time\n");
   printf("of that query, but all records that will eventually be valid\n");
   printf("within a given time window.  The super-cache is in the center\n");
   printf("section of the window represented by a two dimensional array\n");
   printf("of rectangles.  Each rectangle represents a record and has a\n");
   printf("'time number' associated with it.  (This might correspond in\n");
   printf("reality to a departure time, for example.)  As time elapses\n");
   printf("the number on the clock, shown in the upper right hand corner\n");
   printf("of the window, grows and the color of the data records in the \n");
   printf("supercache progresses from white, through shades of green from \n");
   printf("lighter to darker, and then eventually to black. If a\n");
   printf("record's time number falls within a given range from the current\n");
   printf("time forward, in this case 12 units, it is filled with a shade \n");
   printf("green corresponding to its time number.  If the time shown on \n");
   printf("the clock has passed the time number of a given record, that\n");
   printf("record becomes black, and if the time number of a record is\n");
   printf("not yet valid, it is greater than the current time plus the \n");
   printf("time window amount, it is shown white.\n\n");
   printf("Queries are launched at random times by the simulation.  All\n");
   printf("queries are made on a specific column of data in the super cache\n");
   printf("chosen at the beginning of the simulation at random.  \n");
   printf("10 queries are taken in all and lined\n");
   printf("up at the bottom of the screen.  This allows the user to see how\n");
   printf("the query results change over time.  Each query is labeled with\n");
   printf("the time at which it was taken and each record labeled with its\n");
   printf("time number.\n\n");
   printf("Each time a query is made, the records in the data base that \n");
   printf("correspond to the records in the super cache that are a part of\n");
   printf("the query result must be poled to determine if an changes have \n");
   printf("been made.  This is shown by a flashing red outline around a\n");
   printf("rectangle in the data base.  Also, at a random time, a change \n");
   printf("may be made on any given record in the database.\n");
   printf("This is represented by a blue rectangle moving into the data \n");
   printf("base and replacing an old record.  If this changed record is one\n");
   printf("which is contained in the super cache,  and is in the set of \n");
   printf("data records which the query produces, then the super cache will\n");
   printf("be updated at the time of the next query.\n\n");

   printf("enter a number between 0 and 32767:\n");
   scanf("%d", &seed);
//   cout << "enter a number between 0 and 32767:\n";
//   cin >> seed;

   srand(seed);
 
   rval = ((float)(rand()))/32767.0*8.0;
   q_col = (int)rval; 

   tdq.SendAlgoEvt("Init",NULL);

   tdq.SendAlgoEvt("Ready",q_col);

   row = 0;
   while (row<10) {
	rval = ((float)(rand()))/32767.0*((float)MAX_TIME);
        time = (int)rval;
	queries[row] = time;
	for (col=0; col<row; col++) {
	    if (queries[col] == time) row--;
	}
	row++;
   }

/* Load the supercache with random time stamps */

   for (row=0; row<CACHE_X; row++) {
	for (col=0; col<CACHE_Y; col++) {
	    rval = ((float)(rand()))/32767.0*MAX_TIME;
	    scache[row][col] = (int)rval;
	    tdq.SendAlgoEvt("Input",row,col,scache[row][col]);
	}
   }


/* Draw the supercache with the appropriate colors */

   for (row=0; row<CACHE_X; row++) {
	for (col=0; col<CACHE_Y; col++) {
	    if (scache[row][col] < 12) {
		tdq.SendAlgoEvt("Colors",row,col,0);
	    }
	}
   }


   for (time=0; time<=MAX_TIME; time++) {
	tdq.SendAlgoEvt("Clock",time);
   	for (row=0; row<CACHE_X; row++) {
	    for (col=0; col<CACHE_Y; col++) {
		tdq.SendAlgoEvt("Colors",row,col,time);
	    }
	}
	for (row=0; row<10; row++) {
            if (queries[row] <= time) {
                tdq.SendAlgoEvt("Query",q_col,q_num,time);
                q_num++;
                queries[row] = MAX_TIME + 1;
	    }
	}
   }
   while (1)
      tdq.SendAlgoEvt("WAIT");

}

