/***************************************************************/
/*							                                   */
/*	       		print.h	                                       */
/*							                                   */
/***************************************************************/
/*       Copyright 1993, 1997 Georgia Institute of Technology 
                     -- John T. Stasko, Roman S. Khramets      */

#ifndef	__PRINT_H__
#define __PRINT_H__

#ifndef	NO_REDEFS
#define printf		    __win32_printf
#define scanf           __win32_scanf
#define exit		    __win32_exit
#endif

#include <stdio.h>
#include <stdlib.h>

#ifdef __cplusplus
extern "C" {
#endif

int  __cdecl __win32_printf(const char *fmt, ...);
int  __cdecl __win32_scanf(const char *fmt, ...);
void __cdecl __win32_exit(int rv);
void CreateConsole(int x = 0, int y = 0, int width = 0, int height = 0);

#ifdef __cplusplus
}
#endif

#endif
